//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Automates cellulaires 2D  (Vuibert)
//    v:0.0 30/04/2001
//
//  This program shows the capability of a Conway cellular automata to manage
//  boolean functions.
//
//    Jean-Philippe Rennard 2001-2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package ac;

import java.awt.*;
import java.awt.event.*;
import vabase.*;

/** La classe acUI est l'interface de l'automate cellulaire */
public class acUI extends Cui {
  static final String REGLE_DEFAUT="23/3/2";
  static final String INVASION="45678/35678/2";
  static final String LONGUEVIE="5/345/2";
  static final String HEUDIN1133="13/3/2";
  static final String BRIAN="/2/3";
  static final String BELZHAB="23/23/8";
  static final String COOTIES="23/2/8";
  static final String SWIRL="23/34/8";

  /** Pointeur sur l'automate cellulaire */
  private Cac ac;

  // Elments d'interface
  Button btnPas = new Button();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panelVue = new Panel();
  Panel panel2 = new Panel();
  Choice chFigures = new Choice();
  Button btnEfface = new Button();
  Button btnHasard = new Button();
  Button btnGo = new Button();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  TextField tfDens = new TextField();
  TextField tfRegles = new TextField();
  Panel panel6 = new Panel();
  Label label2 = new Label();
  GridLayout gridLayout5 = new GridLayout();
  Panel panel7 = new Panel();
  GridLayout gridLayout6 = new GridLayout();
  Button btnValRegle = new Button();
  Label label3 = new Label();
  Choice chTailles = new Choice();
  Panel panel5 = new Panel();
  GridLayout gridLayout7 = new GridLayout();
  Label lbGeneration = new Label();
  Choice chRegles = new Choice();
  GridLayout gridLayout4 = new GridLayout();

  /** Constructeur : cre l'automate, etc... */
  public acUI(acLaunch am) {
    super((Claunch)am);
    ac=new Cac(this, REGLE_DEFAUT,
                                  Cac.TAILLE_DEFAUT, Cac.TAILLE_DEFAUT);
    process=(Cprocess)ac;
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Initialisation */
  private void jbInit() throws Exception {
    btnPas.setLabel("Pas");
    btnPas.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPas_actionPerformed(e);
      }
    });
    this.setLayout(borderLayout1);
    panelVue.setBackground(SystemColor.control);
    panelVue.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        panelVue_componentResized(e);
      }
    });
    panelVue.setLayout(gridLayout4);
    btnEfface.setLabel("Efface");
    btnEfface.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnEfface_actionPerformed(e);
      }
    });
    btnHasard.setLabel("Hasard");
    btnHasard.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnHasard_actionPerformed(e);
      }
    });
    btnGo.setLabel("Go");
    btnGo.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnGo_actionPerformed(e);
      }
    });
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(4);
    panel3.setLayout(gridLayout2);
    gridLayout2.setColumns(3);
    panel4.setLayout(gridLayout3);
    gridLayout3.setColumns(5);
    tfRegles.setText(REGLE_DEFAUT);
    tfRegles.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        tfRegles_focusGained(e);
      }
    });
    label2.setText("Figures... ");
    panel6.setLayout(gridLayout5);
    gridLayout5.setColumns(2);
    gridLayout5.setHgap(4);
    borderLayout1.setHgap(2);
    borderLayout1.setVgap(2);
    panel7.setLayout(gridLayout6);
    gridLayout6.setColumns(2);
    gridLayout6.setHgap(4);
    btnValRegle.setLabel("Valide");
    btnValRegle.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        btnValRegle_actionPerformed(e);
      }
    });
    chFigures.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        chFigures_itemStateChanged(e);
      }
    });
    label3.setAlignment(1);
    label3.setText("Densit :");
    tfDens.setText("25");
    panel5.setLayout(gridLayout7);
    gridLayout7.setColumns(3);
    gridLayout7.setHgap(4);
    chTailles.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        chTailles_itemStateChanged(e);
      }
    });
    lbGeneration.setAlignment(2);
    lbGeneration.setText("0");
    chRegles.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        chRegles_itemStateChanged(e);
      }
    });
    this.add(panelVue, BorderLayout.CENTER);
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(panel3, null);
    panel3.add(btnGo, null);
    panel3.add(btnPas, null);
    panel3.add(btnEfface, null);
    panel2.add(panel4, null);
    panel4.add(lbGeneration, null);
    panel4.add(label3, null);
    panel4.add(tfDens, null);
    panel4.add(btnHasard, null);
    this.add(panel6, BorderLayout.NORTH);
    panel6.add(panel5, null);
    panel5.add(chRegles, null);
    panel5.add(tfRegles, null);
    panel5.add(btnValRegle, null);
    panel6.add(panel7, null);
    panel7.add(label2, null);
    panel7.add(chFigures, null);
    panel7.add(chTailles, null);
    // Init combo des rgles
    chRegles.addItem("Jeu de la vie");
    chRegles.addItem("Brian's Brain");
    chRegles.addItem("Invasion"); // 45678/35678/2
    chRegles.addItem("Longue vie"); // 5/345/2
    chRegles.addItem("Heudin 1133"); // 13/3/2
    chRegles.addItem("BelZhab");  // 23/23/8
    chRegles.addItem("Cooties");  // 23/2/8
    chRegles.addItem("Swirl"); // 23/34/8
    // Init combo des figures
    chFigures.addItem("R-Pento");
    chFigures.addItem("Planeur");
    chFigures.addItem("Canon");
    chFigures.addItem("Vaisseau");
    chFigures.addItem("Locomotive");
    chFigures.addItem("Coderman");
    chFigures.addItem("Planeur 1133");
    // Init combo des tailles
    chTailles.addItem("10");
    chTailles.addItem("25");
    chTailles.addItem("50");
    chTailles.addItem("100");
    chTailles.addItem("200");
    chTailles.addItem("300");
    chTailles.select(3);
    // Ajout de la vue dans un panel
    panelVue.add(ac.acVue,null);
  }
  /** Remplissage alatoire de la grille */
  void btnHasard_actionPerformed(ActionEvent e) {
    ac.grilleAleat(Integer.parseInt(tfDens.getText()));
    repaint();
  }
  /** Choix d'une rgle dans la liste */
  void chRegles_itemStateChanged(ItemEvent e) {
    switch(chRegles.getSelectedIndex()) {
      case 1:
        tfRegles.setText(BRIAN);
        break;
      case 2:
        tfRegles.setText(INVASION);
        break;
      case 3:
        tfRegles.setText(LONGUEVIE);
        break;
      case 4:
        tfRegles.setText(HEUDIN1133);
        break;
      case 5 :
        tfRegles.setText(BELZHAB);
        break;
      case 6 :
        tfRegles.setText(COOTIES);
        break;
      case 7 :
        tfRegles.setText(SWIRL);
        break;
      default :
        tfRegles.setText(REGLE_DEFAUT);
    }
    creeRegle();
    setInterface(true);
    btnGo.setEnabled(true);
  }
  /** Modification rgles */
  void tfRegles_focusGained(FocusEvent e) {
    setInterface(false);
    tfRegles.setEnabled(true);
    btnValRegle.setEnabled(true);
    btnGo.setEnabled(false);
  }
  /** Validation rgle */
  void btnValRegle_actionPerformed(ActionEvent e) {
    creeRegle();
    setInterface(true);
    btnGo.setEnabled(true);
  }
  /** Cre rgle */
  void creeRegle() {
    ac.effaceGrille();
    if(!ac.setRegles(tfRegles.getText())) {
      JPAlert al=new JPAlert(this, "Rgles invalides. Retour au Jeu de la vie");
      tfRegles.setText(REGLE_DEFAUT);
      ac.setRegles(tfRegles.getText());
    }
  }
  /** Avance pas  pas */
  void btnPas_actionPerformed(ActionEvent e) {
    ac.pasAPas();
  }
  /** Marche/Arrt */
  void btnGo_actionPerformed(ActionEvent e) {
    if(ac.isRunning==false) {
      btnGo.setLabel("Stop");
      setInterface(false);
      ac.lancement();
    }
    else {
      btnGo.setLabel("Go");
      ac.stop();
      setInterface(true);
    }
  }

  /** Efface grille */
  void btnEfface_actionPerformed(ActionEvent e) {
    ac.effaceGrille();
    affGeneration();
  }
  /** Choix figure */
  void chFigures_itemStateChanged(ItemEvent e) {
    ac.ajoutFigure(chFigures.getSelectedIndex());
    affGeneration();
  }
  /** Choix taille automate */
  void chTailles_itemStateChanged(ItemEvent e) {
    int t=Integer.parseInt(chTailles.getSelectedItem());
    ac.setTaille(t, t);
    affGeneration();
  }
  /** Affichage gnration */
  public void affGeneration() {
    lbGeneration.setText(Integer.toString(ac.generation));
  }
  /** (in)activation interface */
  public void setInterface(boolean e) {
    btnPas.setEnabled(e);
    btnEfface.setEnabled(e);
    btnHasard.setEnabled(e);
    btnValRegle.setEnabled(e);
    tfDens.setEnabled(e);
    tfRegles.setEnabled(e);
    chRegles.setEnabled(e);
    chFigures.setEnabled(e);
    chTailles.setEnabled(e);
  }
  /** Redimensionnement de la vue */
  void panelVue_componentResized(ComponentEvent e) {
    redimUi();
  }
}
